package Regexp::TrieEUC;
;#	original code from
;#		mk_trie_regexp.pl,v 0.1 2005/09/10 20:19:44 dankogai
;#		@see http://blog.livedoor.jp/dankogai/archives/50074802.html
;#	copyright (c) 2005 Piroli YUKARINOMIYA. Some rights reserved.
;#		@see http://www.magicvox.net/archive/2005/11051922.php

use strict;
use warnings;
use Jcode;

sub new{ bless {} => shift }
sub add{
    my $self = shift;
    my $str  = shift;
    my $ref  = $self;
    for my $char (Jcode->new($str)->euc
			=~ /[\x00-\x7F]|[\x8E\xA1-\xFE][\xA1-\xFE]|\x8F[\xA1-\xFE][\xA1-\xFE]/og){
			;# @see http://www.din.or.jp/~ohzaki/perl.htm#JP_Split
		$ref->{$char} ||= {};
		$ref = $ref->{$char};
	}
	$ref->{''} = 1;# as terminator
	$self;
}
sub _regexp{
    my $self = shift;
    return if $self->{''} and scalar keys %$self == 1; # terminator
    my (@alt, @cc);
    my $q = 0;
    for my $char (sort keys %$self){
        my $qchar = quotemeta $char;
        if (ref $self->{$char}){
            if (defined (my $recurse = _regexp($self->{$char}))){
                push @alt, $qchar . $recurse;
            }else{
                push @cc, $qchar;
            }
        }else{
            $q = 1;
        }
    }
    my $cconly = !@alt;
    @cc and push @alt, @cc == 1 ? $cc[0] : '(?:'. join('|', @cc). ')';
    my $result = @alt == 1 ? $alt[0] : '(?:' . join('|', @alt) . ')';
    $q and $result = $cconly ? "$result?" : "(?:$result)?";
    $result;
}
sub as_regexp{ my $str = shift->_regexp; qr/$str/ }

1;
